import {CommonModule, isPlatformBrowser} from '@angular/common';
import {
  Component,
  Directive,
  ElementRef,
  EventEmitter,
  Inject,
  Injectable,
  Input,
  NgModule,
  Output,
  PLATFORM_ID
} from '@angular/core';
import {Observable, Subject} from 'rxjs';
import {filter, finalize, take, takeUntil} from 'rxjs/operators';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var InViewportComponent = /** @class */ (function () {
  function InViewportComponent() {
  }

  InViewportComponent.decorators = [
    {
      type: Component, args: [{
        selector: 'aiut-in-viewport',
        template: "<div (inViewport)=\"showMyElement = $event.isIntersecting\" aiutInViewport>\r\n  <ng-content *ngIf=\"showMyElement\"></ng-content>\r\n</div>\r\n"
      }]
    }
  ];
  return InViewportComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ViewportService = /** @class */ (function () {
  function ViewportService() {
    this.options = {
      rootMargin: '0px 0px 0px 0px',
      threshold: [0.5],
    };
    this.callback$ = new Subject();
    this.observer = new IntersectionObserver(this.handler.bind(this), this.options);
  }

  /**
   * @param {?} element
   * @return {?}
   */
  ViewportService.prototype.observe = /**
   * @param {?} element
   * @return {?}
   */
  function (element) {
    var _this = this;
    this.observer.observe(element);
    return this.callback$.asObservable().pipe(filter((/**
     * @param {?} entry
     * @return {?}
     */
    function (entry) {
      return entry.target === element;
    })), finalize((/**
     * @return {?}
     */
    function () {
      return _this.observer.unobserve(element);
    })));
  };
  /**
   * @private
   * @param {?} entries
   * @return {?}
   */
  ViewportService.prototype.handler = /**
   * @private
   * @param {?} entries
   * @return {?}
   */
  function (entries) {
    var _this = this;
    entries.forEach((/**
     * @param {?} entry
     * @return {?}
     */
    function (entry) {
      return _this.callback$.next(entry);
    }));
  };
  ViewportService.decorators = [
    {type: Injectable}
  ];
  /** @nocollapse */
  ViewportService.ctorParameters = function () {
    return [];
  };
  return ViewportService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// create a symbol identify the observable I add to
// the component so it doesn't conflict with anything.
// I need this so I'm able to add the desired behaviour to the component.
/** @type {?} */
var destroy$ = Symbol('destroy$');
/**
 * An operator that takes until destroy it takes a components this a parameter
 * returns a pipeable RxJS operator.
 * @type {?}
 */
var untilDestroy = (/**
 * @template T
 * @param {?} component
 * @return {?}
 */
function (component) {
  if (component[destroy$] === undefined) {
    // only hookup each component once.
    addDestroyObservableToComponent(component);
  }
  // pipe in the takeUntil destroy$ and return the source unaltered
  return takeUntil(component[destroy$]);
});

/**
 * \@internal
 * @param {?} component
 * @return {?}
 */
function addDestroyObservableToComponent(component) {
  component[destroy$] = new Observable((/**
   * @param {?} observer
   * @return {?}
   */
  function (observer) {
    // keep track of the original destroy function,
    // the user might do something in there
    /** @type {?} */
    var orignalDestroy = component.ngOnDestroy;
    if (orignalDestroy == null) {
      // Angular does not support dynamic added destroy methods
      // so make sure there is one.
      throw new Error('untilDestroy operator needs the component to have an ngOnDestroy method');
    }
    // replace the ngOndestroy
    component.ngOnDestroy = (/**
     * @return {?}
     */
    function () {
      // fire off the destroy observable
      observer.next();
      // complete the observable
      observer.complete();
      // and at last, call the original destroy
      orignalDestroy.call(component);
    });
    // return cleanup function.
    return (/**
     * @param {?} _
     * @return {?}
     */
    function (_) {
      return (component[destroy$] = undefined);
    });
  }));
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var InViewportDirective = /** @class */ (function () {
  function InViewportDirective(elementRef, viewportService, platformId) {
    this.elementRef = elementRef;
    this.viewportService = viewportService;
    this.platformId = platformId;
    this.preRender = true;
    this.oneTime = false;
    this.inViewport = new EventEmitter();
  }

  /**
   * @return {?}
   */
  InViewportDirective.prototype.ngOnInit = /**
   * @return {?}
   */
  function () {
    var _this = this;
    if (isPlatformBrowser(this.platformId)) {
      if (this.oneTime) {
        this.viewportService
          .observe(this.elementRef.nativeElement)
          .pipe(untilDestroy(this), filter((/**
           * @param {?} entry
           * @return {?}
           */
          function (entry) {
            return entry.intersectionRatio >= 0.5;
          })), take(1))
          .subscribe((/**
           * @param {?} entry
           * @return {?}
           */
          function (entry) {
            _this.inViewport.emit(entry);
          }));
      } else {
        this.viewportService
          .observe(this.elementRef.nativeElement)
          .pipe(untilDestroy(this))
          .subscribe((/**
           * @param {?} entry
           * @return {?}
           */
          function (entry) {
            _this.inViewport.emit(entry);
          }));
      }
    } else {
      if (this.preRender) {
        this.inViewport.emit({isIntersecting: true, intersectionRatio: 1});
      }
    }
  };
  /**
   * @return {?}
   */
  InViewportDirective.prototype.ngOnDestroy = /**
   * @return {?}
   */
  function () {
  };
  InViewportDirective.decorators = [
    {
      type: Directive, args: [{
        selector: '[aiutInViewport]',
      },]
    }
  ];
  /** @nocollapse */
  InViewportDirective.ctorParameters = function () {
    return [
      {type: ElementRef},
      {type: ViewportService},
      {type: Object, decorators: [{type: Inject, args: [PLATFORM_ID,]}]}
    ];
  };
  InViewportDirective.propDecorators = {
    preRender: [{type: Input}],
    oneTime: [{type: Input}],
    inViewport: [{type: Output}]
  };
  return InViewportDirective;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AitpUtilsModule = /** @class */ (function () {
  function AitpUtilsModule() {
  }

  AitpUtilsModule.decorators = [
    {
      type: NgModule, args: [{
        imports: [CommonModule],
        declarations: [InViewportDirective, InViewportComponent],
        providers: [ViewportService],
        exports: [InViewportDirective, InViewportComponent]
      },]
    }
  ];
  return AitpUtilsModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export {
  AitpUtilsModule,
  InViewportComponent,
  InViewportDirective,
  addDestroyObservableToComponent,
  destroy$,
  untilDestroy,
  ViewportService,
  InViewportComponent as ɵb,
  InViewportDirective as ɵa,
  ViewportService as ɵc
};

//# sourceMappingURL=aitp-utils.js.map
